/**
 ******************************************************************************
 * Xenia : Xbox 360 Emulator Research Project                                 *
 ******************************************************************************
 * Copyright 2014 Ben Vanik. All rights reserved.                             *
 * Released under the BSD license - see LICENSE in the root for more details. *
 ******************************************************************************
 */

#ifndef XENIA_GPU_GL4_GL4_SHADER_H_
#define XENIA_GPU_GL4_GL4_SHADER_H_

#include <xenia/common.h>
#include <xenia/gpu/gl4/gl_context.h>
#include <xenia/gpu/shader.h>

namespace xe {
namespace gpu {
namespace gl4 {

class GL4Shader : public Shader {
 public:
  GL4Shader(ShaderType shader_type, uint64_t data_hash,
            const uint32_t* dword_ptr, uint32_t dword_count);
  ~GL4Shader() override;

  GLuint program() const { return program_; }

  bool PrepareVertexShader(const xenos::xe_gpu_program_cntl_t& program_cntl);
  bool PreparePixelShader(const xenos::xe_gpu_program_cntl_t& program_cntl);

 protected:
  bool CompileProgram(std::string source);

  GLuint program_;
};

}  // namespace gl4
}  // namespace gpu
}  // namespace xe

#endif  // XENIA_GPU_GL4_GL4_SHADER_H_
